import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { Client } from './client';
import { environment } from '../environments/environment';
@Injectable({
  providedIn: 'root'
})
export class ApiService {

  constructor(private http:HttpClient) {}

  httpOptions ={
    headers: new HttpHeaders({
      'Content-type' : 'application/json'
    })
  }
  getAllClients() : Observable<Client[]> {
    return this.http.get<Client[]>(environment.apiUrl);
  }

  getClientById(id:number) : Observable<Client>
  {
    return this.http.get<Client>(`${environment.apiUrl}/${id}`);
  }

  addClient(client:Client) : Observable<Client>
  {
    return this.http.post<Client>(environment.apiUrl, client);
  }

  updateClient(id:number, client:Client) : Observable<Client>
  {
    return this.http.put<Client>(`${environment.apiUrl}/${id}`, client, this.httpOptions)
  }

  deleteClient(id) :Observable<object>
  {
    return this.http.delete<Client>(`${environment.apiUrl}/${id}`, this.httpOptions);
  }


}
